package net.cattaka.rdbassistant.gui;


import net.cattaka.rdbassistant.bean.RdbaSingletonBundle;
import net.cattaka.rdbassistant.config.RdbaConfig;

public interface RdbaGuiInterface {
	/**
	 * 固有のレイアウトの更新を行う。
	 */
	public void doGuiLayout();

	/**
	 * RdbaConfigを取得する。
	 * 基本的に親コンポーネントから取得する。
	 */
	public RdbaConfig getRdbaConfig();
	
	/**
	 * RdbaConfigの再読込を行う。
	 */
	public void reloadRdbaConfig();

	/**
	 * アプリケーション全体へのメッセージの送信
	 * 
	 * @param rdbaMessage
	 */
	public void sendRdbaMessage(RdbaMessage rdbaMessage);
	
	/**
	 * アプリケーションの親元からのメッセージを子に引き渡す。
	 * @param rdbaMessage
	 */
	public void relayRdbaMessage(RdbaMessage rdbaMessage);
	
	/**
	 * システム全体で一つしかないダイアログやコンフィグを取得する。
	 * @return
	 */
	public RdbaSingletonBundle getRdbaSingletonBundle();
}
